#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct Character
{
	float x;
	float y;
	float z;
	int HP;
	int MaxHP;
	int MP;
	int MaxMP;
};

struct Zone
{
	char mapData[0x400]; // Pretend this holds information about the map
	Character *player;
};

Zone *pZone;
int main(int argc, char **argv)
{
	// Initiate our zone and character list
	pZone = new Zone;
	pZone->player = new Character;
	pZone->player->HP = 1234;

	printf("pZone is located at 0x%p and points to 0x%p\n", &pZone, pZone);
	printf("Zone is located at 0x%p and points to 0x%p\n", pZone, *pZone);

	int player_offset = (int)(&pZone->player) - (int)(pZone);
	printf("player is located at 0x%p + 0x%X = 0x%p\n", pZone, player_offset, &pZone->player);

	int HP_offset = (int)(&pZone->player->HP) - (int)(pZone->player);
	printf("Player HP is %d and located at 0x%p + 0x%X = (0x%p)\n",
		pZone->player->HP, pZone->player, HP_offset, &pZone->player->HP);



	printf("\n\nContinue to change HP\n");
	while(true)
	{
		system("pause");
		pZone->player->HP++;
		if( pZone->player->HP > 2000 )
			pZone->player->HP = 1000;

		printf("Character HP is %d and located at 0x%p + 0x%X\n",
			pZone->player->HP, &pZone->player, HP_offset);
	}

	delete pZone->player;
	delete pZone;

    return 0;
}
